const sext = @import("zba-util").sext;

pub fn clz(comptime InstrFn: type) InstrFn {
    const Arm32 = @typeInfo(@typeInfo(@typeInfo(InstrFn).Pointer.child).Fn.params[0].type.?).Pointer.child;

    return struct {
        pub fn inner(cpu: *Arm32, opcode: u32) void {
            const rd = opcode >> 12 & 0xF;
            const rm = opcode & 0xF;

            if (rd == 0xF) cpu.panic("CLZ: UNPREDICTABLE behaviour when rd == 15", .{});
            if (rm == 0xF) cpu.panic("CLZ: UNPREDICTABLE behaviour when rm == 15", .{});

            cpu.r[rd] = @clz(cpu.r[rm]);
        }
    }.inner;
}
