const rotr = @import("zba-util").rotr;

pub fn singleDataSwap(comptime InstrFn: type, comptime B: bool) InstrFn {
    const Arm32 = @typeInfo(@typeInfo(@typeInfo(InstrFn).Pointer.child).Fn.params[0].type.?).Pointer.child;

    return struct {
        fn inner(cpu: *Arm32, opcode: u32) void {
            const rn = opcode >> 16 & 0xF;
            const rd = opcode >> 12 & 0xF;
            const rm = opcode & 0xF;

            const address = cpu.r[rn];

            if (B) {
                // SWPB
                const value = cpu.read(u8, address);

                // FIXME: I shouldn't have to use @as(u8, ...) here
                cpu.write(u8, address, @as(u8, @truncate(cpu.r[rm])));
                cpu.r[rd] = value;
            } else {
                // SWP
                const value = rotr(u32, cpu.read(u32, address), 8 * (address & 0x3));
                cpu.write(u32, address, cpu.r[rm]);
                cpu.r[rd] = value;
            }
        }
    }.inner;
}
